<?php
/*
Plugin Name: Smart RSS
Plugin URI: http://www.devplug.net
Description: SmartRss cron job feed importer.
Version: 1.1.0
Author: Liuta Ovidiu
Author URI: http://www.devplug.net/
*/
require_once('wp-config.php');

// function to replace file_get_contents()
function file_get_the_contents($url) {
  $ch = curl_init();
  $timeout = 5; // set to zero for no timeout
  curl_setopt ($ch, CURLOPT_URL, $url);
  curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
  $file_contents = curl_exec($ch);
  curl_close($ch);
  return $file_contents;
}



$C_SIZE = (int)get_option("rss_c_size");
if($C_SIZE > 0)
 print "<h2>Posts filtered to minimum $C_SIZE characters</h2>";
 
$D_LIMIT = (int)get_option("rss_feed_limit");

if($D_LIMIT == 0)
 $D_LIMIT = 10;



class SmartRss {
   var $title;
   var $link;
   var $description;
   function SmartRss ($aa)
   {
       foreach ($aa as $k=>$v)
           $this->$k = $aa[$k];
   }
}

function readDatabase($filename)
{
   // read the XML database of aminoacids

   if($data = file_get_the_contents($filename)){
     //$data = @implode("", $content);
   }else{
     print "<h2>Unable to read feed <font color=red>$filename</font></h2>";}
   $parser = xml_parser_create();
   xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
   xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
   xml_parse_into_struct($parser, $data, $values, $tags);
   xml_parser_free($parser);


   // loop through the structures
   foreach ($tags as $key=>$val) {
       if ($key == "item") {
           $molranges = $val;
           // each contiguous pair of array entries are the
           // lower and upper range for each molecule definition
           for ($i=0; $i < count($molranges); $i+=2) {
                   $offset = $molranges[$i] + 1;
               $len = $molranges[$i + 1] - $offset;
               $tdb[] = parseMol(array_slice($values, $offset, $len));
           }
       } else {
           continue;
       }
   }
   return $tdb;
}

function parseMol($mvalues)
{
   for ($i=0; $i < count($mvalues); $i++) {
       $mol[$mvalues[$i]["tag"]] = $mvalues[$i]["value"];
   }
   return new SmartRss($mol);
}




$res=$wpdb->get_results("select * from ".$table_prefix."smartrss where active=1");

if(!is_array($res))
 $res = array();

$incf = 0;

foreach($res as $rss_fields)
{

$db = readDatabase($rss_fields->rss_source);

$post_category=$rss_fields->cat_ID;

$db_size = sizeof($db);

echo "<h3>Reading ".$rss_fields->rss_source." - ".$db_size." posts available</h3>";

if($D_LIMIT < $db_size)
 $limit = $D_LIMIT;
else
 $limit = $db_size;
 
for($i=0;$i<$limit;$i++)
{
 $res=mysql_query("select * from ".$table_prefix."posts where post_title='".addslashes($db[$i]->title)."'");
 if(mysql_num_rows($res)==0)
 {
  $incf++;
  

 $data=$db[$i]->description."\r\n\r\n<br><br>"."<b>More:</b> <a target='_blank' href='".$db[$i]->link."'> continued here </a>";
 if($incf == 6){

     $sponsor = " <br /><a href='http://www.devplug.net'>Powered by SmartRSS</a>";
     $incf = 0;
     $data .= $sponsor;
     }
 if(strlen(strip_tags($data))>= $C_SIZE ){

   echo "<br><br>\r\n\r\n Inserting ".stripslashes($db[$i]->title);
   $query="INSERT INTO ".$table_prefix."posts set
                                            ID='',
                                            post_title='".addslashes($db[$i]->title)."',
                                            post_content='".addslashes($data)."',
                                            post_author='1',
                                            post_date='".date("Y-m-d H:m:s",time()-rand(60,3600*4))."',
                                            post_date_gmt='".date("Y-m-d H:m:s",time()-rand(60,3600*4))."',
                                            post_status='publish',
                                            post_category='".$post_category."',
                                            post_name='". sanitize_title($db[$i]->title)."',
                                            comment_status='open'";
   mysql_query($query) ;
   $id=mysql_insert_id();
 
   #mysql_query("INSERT INTO ".$table_prefix."post2cat set post_id='".$id."', category_id='".$post_category."'");
   mysql_query("INSERT INTO ".$table_prefix."term_relationships  set object_id='".$id."', term_taxonomy_id='".$post_category."'");
   mysql_query("INSERT INTO ".$table_prefix."postmeta set post_id='".$id."', meta_key='keywords',meta_value='".str_replace("-",",",sanitize_title($db[$i]->title))."'");
   mysql_query("INSERT INTO ".$table_prefix."postmeta set post_id='".$id."', meta_key='description',meta_value='".addslashes($db[$i]->title)."'");
   mysql_query("UPDATE ".$table_prefix."term_taxonomy set count=count+1 WHERE term_id = '".$post_category."'");
 }
   
 }

}

}



?>
